#include <kos.h>
#include "smashdc.h"
#include "vars.h"

void UpdateControls()
{
	UpdateControlSet( 0 );
	UpdateControlSet( 1 );
	UpdateControlSet( 2 );
	UpdateControlSet( 3 );
}

uint8 GetPortAddr( int port )
{
	uint8 addr;

	addr=maple_addr( port, 0 );

	return addr;
}

int PadInPort( int port )
{
	int retval=FALSE;

	if ( maple_device_func( port, 0 ) == MAPLE_FUNC_CONTROLLER )
		retval=TRUE;

	return retval;
}

void UpdateControlSet( uint8 index )
{
	uint8 mcont = 0;
	cont_cond_t cond;

	mcont = GetPortAddr( index );

	if (cont_get_cond(mcont, &cond))
	{
		//printf("Error getting controller status\n");
	}
	else
	{
		if (!(cond.buttons & CONT_DPAD_UP))
			ControlSets[index].Up=TRUE;
		else ControlSets[index].Up=FALSE;

		if (!(cond.buttons & CONT_DPAD_DOWN))
			ControlSets[index].Down=TRUE;
		else ControlSets[index].Down=FALSE;

		if (!(cond.buttons & CONT_DPAD_LEFT))
			ControlSets[index].Left=TRUE;
		else ControlSets[index].Left=FALSE;

		if (!(cond.buttons & CONT_DPAD_RIGHT))
			ControlSets[index].Right=TRUE;
		else ControlSets[index].Right=FALSE;

		if (!(cond.buttons & CONT_Y))
			ControlSets[index].ShootUp=TRUE;
		else ControlSets[index].ShootUp=FALSE;

		if (!(cond.buttons & CONT_A))
			ControlSets[index].ShootDown=TRUE;
		else ControlSets[index].ShootDown=FALSE;

		if (!(cond.buttons & CONT_X))
			ControlSets[index].ShootLeft=TRUE;
		else ControlSets[index].ShootLeft=FALSE;

		if (!(cond.buttons & CONT_B))
			ControlSets[index].ShootRight=TRUE;
		else ControlSets[index].ShootRight=FALSE;

		if (!(cond.buttons & CONT_START))
		{
			ControlSets[index].Exit=TRUE;
		}
		else
			ControlSets[index].Exit=FALSE;
	}
}

