#include <kos.h>
#include "smashdc.h"
#include "vars.h"

void DrawPlayerBullets()
{
	int i;

	for ( i=0; i<MAX_BULLETS; i++ )
	{
		if ( PlayerBullets[i].Active == TRUE )
		{
			switch( PlayerBullets[i].Type )
			{
				case WEAPON_BULLET:
					switch( PlayerBullets[i].Direction )
					{
						case UP:
							DrawPlayerBullet( NormalBulletUp.Frames[0], PlayerBullets[i].XPos,
							PlayerBullets[i].YPos, 16, 16 );
							break;
						case DOWN:
							DrawPlayerBullet( NormalBulletDown.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case LEFT:
							DrawPlayerBullet( NormalBulletLeft.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case RIGHT:
							DrawPlayerBullet( NormalBulletRight.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case UPLEFT:
							DrawPlayerBullet( NormalBulletUpLeft.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case UPRIGHT:
							DrawPlayerBullet( NormalBulletUpRight.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case DOWNLEFT:
							DrawPlayerBullet( NormalBulletDownLeft.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case DOWNRIGHT:
							DrawPlayerBullet( NormalBulletDownRight.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
					}
					break;
				case WEAPON_ROCKET:
					switch( PlayerBullets[i].Direction )
					{
						case UP:
							DrawPlayerBullet( RocketBulletUp.Frames[0], PlayerBullets[i].XPos,
							PlayerBullets[i].YPos, 16, 16 );
							break;
						case DOWN:
							DrawPlayerBullet( RocketBulletDown.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case LEFT:
							DrawPlayerBullet( RocketBulletLeft.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case RIGHT:
							DrawPlayerBullet( RocketBulletRight.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case UPLEFT:
							DrawPlayerBullet( RocketBulletUpLeft.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case UPRIGHT:
							DrawPlayerBullet( RocketBulletUpRight.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case DOWNLEFT:
							DrawPlayerBullet( RocketBulletDownLeft.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
						case DOWNRIGHT:
							DrawPlayerBullet( RocketBulletDownRight.Frames[0], PlayerBullets[i].XPos,
								PlayerBullets[i].YPos, 16, 16 );
							break;
					}
					break;
				}
		}
	}

}

void DrawPlayerBullet( uint32 spriteindex, int xpos, int ypos, int width, int height )
{

  poly_hdr_t poly;
  vertex_ot_t vert;

  ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB1555_TWID, 8, 8, spriteindex, TA_NO_FILTER);
  ta_commit_poly_hdr(&poly);

  vert.r = vert.g = vert.b = 1.0f;
  vert.a = 1.0f;
  vert.oa = vert.or = vert.ob = 0.0f;
  vert.flags = TA_VERTEX_NORMAL;

  vert.x = xpos-(width/2);
  vert.y = ypos-(height/2);
  vert.z = 2;
  vert.u = 0.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+(width/2);
  vert.y = ypos-(height/2);
  vert.z = 2;
  vert.u = 1.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos-(width/2);
  vert.y = ypos+(height/2);
  vert.z = 2;
  vert.u = 0.0;
  vert.v = 1.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+(width/2);
  vert.y = ypos+(height/2);
  vert.z = 2;
  vert.u = 1.0;
  vert.v = 1.0;
  vert.flags = TA_VERTEX_EOL;
  ta_commit_vertex(&vert, sizeof(vert));
}
