#include <kos.h>
#include "smashdc.h"
#include "vars.h"

void DrawPanel( uint32 tex, int xpos, int ypos )
{
  poly_hdr_t poly;
  vertex_ot_t vert;

  ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB1555_TWID, 128, 128, tex, TA_BILINEAR_FILTER);
  ta_commit_poly_hdr(&poly);

  vert.r = vert.g = vert.b = 1.0f;
  vert.a = 1.0f;
  vert.oa = vert.or = vert.ob = 0.0f;
  vert.flags = TA_VERTEX_NORMAL;

  vert.x = xpos;
  vert.y = ypos;
  vert.z = 5;
  vert.u = 0.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+165;
  vert.y = ypos;
  vert.z = 5;
  vert.u = 1.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos;
  vert.y = ypos+125;
  vert.z = 5;
  vert.u = 0.0;
  vert.v = 1.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+165;
  vert.y = ypos+125;
  vert.z = 5;
  vert.u = 1.0;
  vert.v = 1.0;
  vert.flags = TA_VERTEX_EOL;
  ta_commit_vertex(&vert, sizeof(vert));
}

void DrawLifePanels()
{
	DrawPanel( LifePanels[0], 20, 25 );
	DrawPanel( LifePanels[1], 465, 25 );
}

void DrawRoom()
{
	DrawFloor( Floors[Rooms[CurrentRoom].Floor] );
}
