#include <kos.h>
#include "smashdc.h"
#include "vars.h"

void DrawSprite( uint32 spriteindex, int xpos, int ypos, int width, int height, int texwidth, int texheight )
{
  poly_hdr_t poly;
  vertex_ot_t vert;

  ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB1555_TWID, texwidth, texheight, spriteindex, TA_NO_FILTER);
  ta_commit_poly_hdr(&poly);

  vert.r = vert.g = vert.b = 1.0f;
  vert.a = 1.0f;
  vert.oa = vert.or = vert.ob = 0.0f;
  vert.flags = TA_VERTEX_NORMAL;

  vert.x = xpos-(width/2);
  vert.y = ypos-height;
  vert.z = 2;
  vert.u = 0.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+(width/2);
  vert.y = ypos-height;
  vert.z = 2;
  vert.u = 1.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos-(width/2);
  vert.y = ypos;
  vert.z = 2;
  vert.u = 0.0;
  vert.v = 1.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+(width/2);
  vert.y = ypos;
  vert.z = 2;
  vert.u = 1.0;
  vert.v = 1.0;
  vert.flags = TA_VERTEX_EOL;
  ta_commit_vertex(&vert, sizeof(vert));
}
