#include <kos.h>
#include <png/png.h>
#include <oggvorbis/sndoggvorbis.h>
#include "smashdc.h"
#include "vars.h"

void DrawLoadingScreen( uint32 splash, float rgb );

void BeginLoadingScreen()
{
	int done;
	uint32 w, h;
	float rgb;
	uint32 loadingscreen;

	png_load_texture("/cd/data/splash/loading.png", &loadingscreen, PNG_NO_ALPHA, &w, &h);

	done=FALSE; rgb=0.0f;
	while ( done == FALSE )
	{
		ta_begin_render();
		DrawLoadingScreen( loadingscreen, rgb );
		ta_commit_eol();
		ta_finish_frame();

		if ( rgb > 1.00f )
		{
			done=TRUE;
		}
		else
			rgb+=0.01f;
	}
	pvr_mem_reset();
	sndoggvorbis_stop();
}

void EndLoadingScreen()
{
	int done;
	uint32 w, h;
	float rgb;
	uint32 loadingscreen;

	png_load_texture("/cd/data/splash/loading.png", &loadingscreen, PNG_NO_ALPHA, &w, &h);

	done=FALSE; rgb=1.0f;
	while ( done == FALSE )
	{
		ta_begin_render();
		DrawLoadingScreen( loadingscreen, rgb );
		ta_commit_eol();
		ta_finish_frame();

		if ( rgb < 0.00f )
		{
			done=TRUE;
		}
		else
			rgb-=0.01f;
	}
	//pvr_mem_reset();
}

void DrawLoadingScreen( uint32 splash, float rgb )
{
  poly_hdr_t poly;
  vertex_ot_t vert;

  ta_poly_hdr_txr(&poly, TA_OPAQUE, TA_RGB565_TWID, 512, 512, splash, TA_BILINEAR_FILTER);
  ta_commit_poly_hdr(&poly);

  vert.r = vert.g = vert.b = rgb;
  vert.a = 1.0f;
  vert.oa = vert.or = vert.ob = 0.0f;
  vert.flags = TA_VERTEX_NORMAL;

  vert.x = 0;
  vert.y = 0;
  vert.z = 1;
  vert.u = 0.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = 640;
  vert.y = 0;
  vert.z = 1;
  vert.u = 1.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = 0;
  vert.y = 480;
  vert.z = 1;
  vert.u = 0.0;
  vert.v = 1.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = 640;
  vert.y = 480;
  vert.z = 1;
  vert.u = 1.0;
  vert.v = 1.0;
  vert.flags = TA_VERTEX_EOL;
  ta_commit_vertex(&vert, sizeof(vert));
}

