#include <kos.h>
#include <png/png.h>
#include <oggvorbis/sndoggvorbis.h>
#include "smashdc.h"
#include "vars.h"

void DrawSplash( uint32 splash, float rgb );

void DoSplashScreens()
{
	int done,fadein;
	float rgb;
	uint32 w, h;
	uint32 dcemusplash;
	uint32 sigglersplash;

	png_load_texture("/cd/data/splash/dcemu.png", &dcemusplash, PNG_NO_ALPHA, &w, &h);
	png_load_texture("/cd/data/splash/mrsiggler.png", &sigglersplash, PNG_NO_ALPHA, &w, &h);

	snd_sfx_load("/cd/data/sounds/siggler.wav");

	// begin draw cycle..
	done=FALSE; rgb=0.00f; fadein=TRUE;
	while ( done == FALSE )
	{
		ta_begin_render();
		DrawSplash( dcemusplash, rgb );
		ta_commit_eol();
		ta_finish_frame();

		if ( rgb > 1.00f && fadein==TRUE )
		{
			fadein=FALSE;
			timer_spin_sleep( 2000 );
		}
		else if ( rgb < 0.00f && fadein==FALSE )
		{
			done=TRUE;
		}
		else
		{
			if ( fadein==TRUE )
				rgb+=0.01f;
			if ( fadein==FALSE )
				rgb-=0.01f;
		}
	}

	done=FALSE; rgb=0.0f; fadein=TRUE;
	while ( done == FALSE )
	{
		ta_begin_render();
		DrawSplash( sigglersplash, rgb );
		ta_commit_eol();
		ta_finish_frame();

		if ( rgb > 1.00f && fadein==TRUE )
		{
			fadein=FALSE;
			snd_sfx_play( 0, 255, 128 );
			timer_spin_sleep( 2500 );
		}
		else if ( rgb < 0.00f && fadein==FALSE )
		{
			done=TRUE;
		}
		else
		{
			if ( fadein==TRUE )
				rgb+=0.01f;
			if ( fadein==FALSE )
				rgb-=0.01f;
		}
	}
	sndoggvorbis_stop();
	snd_sfx_unload_all();
	pvr_mem_reset();
}

void DrawSplash( uint32 splash, float rgb )
{
  poly_hdr_t poly;
  vertex_ot_t vert;

  ta_poly_hdr_txr(&poly, TA_OPAQUE, TA_RGB565_TWID, 512, 512, splash, TA_BILINEAR_FILTER);
  ta_commit_poly_hdr(&poly);

  vert.r = vert.g = vert.b = rgb;
  vert.a = 1.0f;
  vert.oa = vert.or = vert.ob = 0.0f;
  vert.flags = TA_VERTEX_NORMAL;

  vert.x = 0;
  vert.y = 0;
  vert.z = 1;
  vert.u = 0.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = 640;
  vert.y = 0;
  vert.z = 1;
  vert.u = 1.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = 0;
  vert.y = 480;
  vert.z = 1;
  vert.u = 0.0;
  vert.v = 1.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = 640;
  vert.y = 480;
  vert.z = 1;
  vert.u = 1.0;
  vert.v = 1.0;
  vert.flags = TA_VERTEX_EOL;
  ta_commit_vertex(&vert, sizeof(vert));
}

