#include <kos.h>
#include <time.h>
#include "smashdc.h"

int8 ExitGame;

uint8 CurrentRoom;
int8 BossActive;
int8 BossDead;

uint32 Time;

int8 StartPressed;

uint8 contestants;
uint8 difficulty;
uint8 gamemode;
uint8 music;

// Textures.
uint32 Floors[2];   // 5 different floors per level..
uint32 LifePanels[2]; // 2 Life panels per level..
uint32 Overlays[2]; // 5 overlays

uint32 NumberTextures[10];

uint32 PlayerDead;
uint32 Map;
uint32 InRoom;
uint32 Player1;
uint32 Player2;
uint32 Player3;
uint32 Player4;
uint32 PauseLogo;

uint32 ItemMine;
uint32 Item1Up;
uint32 ItemMoney;
uint32 ItemGold;
uint32 ItemSilver;
uint32 ItemRocket;

uint32 CompleteAll;

int UpArrowAnimFrame;
int UpArrowAnimPos;

int DownArrowAnimFrame;
int DownArrowAnimPos;

int LeftArrowAnimFrame;
int LeftArrowAnimPos;

int RightArrowAnimFrame;
int RightArrowAnimPos;

Animation ExitUp;
Animation ExitDown;
Animation ExitLeft;
Animation ExitRight;
Animation ExitSign;

Animation PlayerLegsUp;
Animation PlayerLegsDown;
Animation PlayerLegsLeft;
Animation PlayerLegsRight;
Animation PlayerLegsUpLeft;
Animation PlayerLegsUpRight;
Animation PlayerLegsDownLeft;
Animation PlayerLegsDownRight;

Animation RedPlayerTorsoUp;
Animation RedPlayerTorsoDown;
Animation RedPlayerTorsoLeft;
Animation RedPlayerTorsoRight;
Animation RedPlayerTorsoUpLeft;
Animation RedPlayerTorsoUpRight;
Animation RedPlayerTorsoDownLeft;
Animation RedPlayerTorsoDownRight;
Animation RedPlayerTorsoUpShoot;
Animation RedPlayerTorsoDownShoot;
Animation RedPlayerTorsoLeftShoot;
Animation RedPlayerTorsoRightShoot;
Animation RedPlayerTorsoUpLeftShoot;
Animation RedPlayerTorsoUpRightShoot;
Animation RedPlayerTorsoDownLeftShoot;
Animation RedPlayerTorsoDownRightShoot;

Animation GreenPlayerTorsoUp;
Animation GreenPlayerTorsoDown;
Animation GreenPlayerTorsoLeft;
Animation GreenPlayerTorsoRight;
Animation GreenPlayerTorsoUpLeft;
Animation GreenPlayerTorsoUpRight;
Animation GreenPlayerTorsoDownLeft;
Animation GreenPlayerTorsoDownRight;
Animation GreenPlayerTorsoUpShoot;
Animation GreenPlayerTorsoDownShoot;
Animation GreenPlayerTorsoLeftShoot;
Animation GreenPlayerTorsoRightShoot;
Animation GreenPlayerTorsoUpLeftShoot;
Animation GreenPlayerTorsoUpRightShoot;
Animation GreenPlayerTorsoDownLeftShoot;
Animation GreenPlayerTorsoDownRightShoot;

Animation BluePlayerTorsoUp;
Animation BluePlayerTorsoDown;
Animation BluePlayerTorsoLeft;
Animation BluePlayerTorsoRight;
Animation BluePlayerTorsoUpLeft;
Animation BluePlayerTorsoUpRight;
Animation BluePlayerTorsoDownLeft;
Animation BluePlayerTorsoDownRight;
Animation BluePlayerTorsoUpShoot;
Animation BluePlayerTorsoDownShoot;
Animation BluePlayerTorsoLeftShoot;
Animation BluePlayerTorsoRightShoot;
Animation BluePlayerTorsoUpLeftShoot;
Animation BluePlayerTorsoUpRightShoot;
Animation BluePlayerTorsoDownLeftShoot;
Animation BluePlayerTorsoDownRightShoot;

Animation YellowPlayerTorsoUp;
Animation YellowPlayerTorsoDown;
Animation YellowPlayerTorsoLeft;
Animation YellowPlayerTorsoRight;
Animation YellowPlayerTorsoUpLeft;
Animation YellowPlayerTorsoUpRight;
Animation YellowPlayerTorsoDownLeft;
Animation YellowPlayerTorsoDownRight;
Animation YellowPlayerTorsoUpShoot;
Animation YellowPlayerTorsoDownShoot;
Animation YellowPlayerTorsoLeftShoot;
Animation YellowPlayerTorsoRightShoot;
Animation YellowPlayerTorsoUpLeftShoot;
Animation YellowPlayerTorsoUpRightShoot;
Animation YellowPlayerTorsoDownLeftShoot;
Animation YellowPlayerTorsoDownRightShoot;

Animation NormalBulletUp;
Animation NormalBulletDown;
Animation NormalBulletLeft;
Animation NormalBulletRight;
Animation NormalBulletUpLeft;
Animation NormalBulletUpRight;
Animation NormalBulletDownLeft;
Animation NormalBulletDownRight;

Animation RocketBulletUp;
Animation RocketBulletDown;
Animation RocketBulletLeft;
Animation RocketBulletRight;
Animation RocketBulletUpLeft;
Animation RocketBulletUpRight;
Animation RocketBulletDownLeft;
Animation RocketBulletDownRight;

Animation SnakeManWalkUp;
Animation SnakeManWalkDown;
Animation SnakeManWalkLeft;
Animation SnakeManWalkRight;

Animation SkullManWalkUp;
Animation SkullManWalkDown;
Animation SkullManWalkLeft;
Animation SkullManWalkRight;

Animation GeminiManWalkUp;
Animation GeminiManWalkDown;
Animation GeminiManWalkLeft;
Animation GeminiManWalkRight;

Animation PharaohManWalkUp;
Animation PharaohManWalkDown;
Animation PharaohManWalkLeft;
Animation PharaohManWalkRight;

Animation TopManWalkUp;
Animation TopManWalkDown;
Animation TopManWalkLeft;
Animation TopManWalkRight;

Animation WoodManWalkUp;
Animation WoodManWalkDown;
Animation WoodManWalkLeft;
Animation WoodManWalkRight;

Animation BombManWalkUp;
Animation BombManWalkDown;
Animation BombManWalkLeft;
Animation BombManWalkRight;

Animation NeedleManWalkUp;
Animation NeedleManWalkDown;
Animation NeedleManWalkLeft;
Animation NeedleManWalkRight;

Animation DrWilyWalkUp;
Animation DrWilyWalkDown;
Animation DrWilyWalkLeft;
Animation DrWilyWalkRight;

Animation EnemyDeath;
Animation BombDeath;

_room Rooms[20];
_effect Effects[MAX_ENEMIES];
_enemy Enemies[MAX_ENEMIES];
_playerbullet PlayerBullets[MAX_BULLETS];
_player Players[5];
_controlset ControlSets[4];
